#include <stdio.h>
#include <stdlib.h>

#include <windows.h>

#ifndef CaptureStackBackTrace
USHORT WINAPI RtlCaptureStackBackTrace(ULONG FramesToSkip, ULONG FramesToCapture, PVOID *BackTrace, PULONG BackTraceHash);
#  define CaptureStackBackTrace RtlCaptureStackBackTrace
#endif

static void function_c(void) {
	PVOID frames[100];
	printf("Stack trace...\n");

	int numframes = CaptureStackBackTrace(0, 30, &frames[0], NULL);

	char buf[4000];
	char* p = &buf[0];
	int i; /* would put this in the for loop but that would need C99 standard */
	for (i = 0; i < numframes; ++i)
		p += sprintf(p, "0x%p\n", frames[i]);

	FILE* f = fopen("dump.dmp", "w");
	fprintf(f, "%s", buf);
	fclose(f);
}

void function_b(void) {
	printf("Calling function_c...\n");
	function_c();
	printf("Returning from function_c...\n");

}

void function_a(void) {
	printf("Calling function_b...\n");
	function_b();
	printf("Returning from function_b...\n");
}

int main(int argc, char *argv[]) {

	printf("Calling function_a...\n");
	function_a();
	printf("Returning from function_a...\n");

}